; GUI #
; 
;  4kogltutor\bin\sharpe.exe
include win64a.inc
; --------------- 
WINDOWWIDTH  = 440
WINDOWHEIGHT = 400

.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	push	sizeof WNDCLASSEX       ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_TIMER
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;     ()
	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST;
;     
	invoke glMatrixMode,GL_PROJECTION;     ()
;    , ..    (  glcall ..     8 )
	movq	xmm0,constd90_0
	movq	xmm1,ratio
	movq	xmm2,constd0_1
	movq	xmm3,constd100_0
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	SetTimer,hWin,10,25,0;  #10  25mSec
        jmp	wmBYE
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0;     
;        invoke	glMatrixMode,GL_PROJECTION;     
;	invoke	glLoadIdentity;		   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
; --------------- Display the scene
;  
	invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke glLoadIdentity
;     (z=-5   =-1,5)
	movd	xmm0,const_1_5;ebx
	movd	xmm1,ebx
	movd	xmm2,const_5_0
	invoke	glTranslatef
;   (    ).
; MSDN   .      
;(  glRotatef    ).   
;     OpenGL -    . 
; ,     OpenGL  
;   (,     
; ,     )
;      
	mov	eax,const1_0
	movd	xmm3,eax
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,Trot
	invoke	glRotatef
	invoke glBegin,GL_TRIANGLES
; 1- 
	movd	xmm2,ebx
	movd	xmm1,ebx
	movd	xmm0,const1_0
        invoke	glColor3f
; 1- 
	movd	xmm0,ebx
	movd	xmm1,const1_0
	movd	xmm2,ebx;const1_0
	invoke	glVertex3f;  
; 2- 
	movd	xmm2,ebx
	movd	xmm1,const1_0
	movd	xmm0,ebx
        invoke	glColor3f
; 2- 
	mov	eax,const_1_0
	movd	xmm0,eax
	movd	xmm1,eax
	movd	xmm2,ebx;const_1_0
	invoke	glVertex3f;  
; 3- 
	movd	xmm2,const1_0
	movd	xmm1,ebx
	movd	xmm0,ebx
        invoke	glColor3f
; 3- 
	movd	xmm0,const1_0
	movd	xmm1,const_1_0
	movd	xmm2,ebx
	invoke	glVertex3f;  
;  
	invoke	glEnd
;------------------------------------------------
	invoke	glLoadIdentity
	movd	xmm0,const1_5;ebx
	movd	xmm1,ebx
	movd	xmm2,const_5_0
	invoke	glTranslatef
	movd	xmm2,const0_4
	movd	xmm1,const0_2
	movd	xmm0,const0_3
        invoke	glColor3f
	mov	eax,const1_0
	movd	xmm3,eax
	movd	xmm2,eax
	movd	xmm1,eax
	movd	xmm0,Qrot
	invoke	glRotatef
	invoke glBegin,GL_QUADS
; 1- 
	movd	xmm0,const_1_0
	movd	xmm1,const1_0
	movd	xmm2,ebx;const1_0
	invoke	glVertex3f;  
; 2- 
	mov	eax,const1_0
	movd	xmm0,eax
	movd	xmm1,eax
	movd	xmm2,ebx;const_1_0
	invoke	glVertex3f;  
; 3- 
	movd	xmm0,const1_0
	movd	xmm1,const_1_0
	movd	xmm2,ebx
	invoke	glVertex3f;  
; 4- 
	mov	eax,const_1_0
	movd	xmm0,eax
	movd	xmm1,eax
	movd	xmm2,ebx
	invoke	glVertex3f;  
	invoke	glEnd
        invoke  glFlush
;   
        invoke	SwapBuffers,hDC
	fld	Trot
	fadd	delta
	fstp	Trot
	fld	Qrot
	fsub	delta
	fstp	Qrot
wmBYE:	leave
	retn	
WndProc	endp
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "Uncle Remus tales:#40 OpenGL",0
FileName	db "..\..\Images\br_Rabbit3.cur",0
ratio		dq	1.33333333333333333333333333333;800/600=1,33333333333333333333333333333
Trot		dd 0.0
Qrot		dd 0.0
delta		dd 0.3
const0_2	dd 0.2
const0_3	dd 0.3
const0_4	dd 0.4
const1_0	dd 1.0
const_1_0	dd -1.0
const_1_5	dd -1.5
const1_5	dd 1.5
const_5_0	dd -5.0
constd90_0	dq 90.0
constd0_1	dq 0.1
constd100_0	dq 100.0
end